#include <bits/stdc++.h>
#define pb push_back

using namespace std;

typedef long long ll;
typedef vector < ll > vll;

ll n, S, m;
vector < vll > p;
vll pref_sums, suf_sums;

void generatePref(ll pos, ll sum)
{
    if(pos == S)
    {
        pref_sums.pb(sum);
        return;
    }

    for(ll i = 0; i<n; i++) generatePref(pos+1, sum + p[pos][i]);
}

void generateSuf(ll pos, ll sum)
{
    if(pos == m)
    {
        suf_sums.pb(sum);
        return;
    }

    for(ll i = 0; i<n; i++) generateSuf(pos+1, sum + p[pos][i]);
}

ll h(ll x)
{
    return lower_bound(suf_sums.begin(), suf_sums.end(), x) - suf_sums.begin();
}

void g1(ll pos, ll sum, ll x, ll &cur)
{
    if(x-sum+1 < 0) return;

    if(pos == S)
    {
        cur += h(x-sum+1) - h(x-sum);
        return;
    }

    for(ll i = 0; i<n; i++) g1(pos+1, sum + p[pos][i], x, cur);
}

void g2(ll pos, ll sum, ll x, ll &cur)
{
    if(x-sum < 0) return;

    if(pos == m)
    {
        if(x == sum) cur++;
        return;
    }

    for(ll i = 0; i<n; i++) g1(pos+1, sum + p[pos][i], x, cur);
}

ll f(ll x)
{
    ll cnt = 0;
    for(ll i = 0; i<pref_sums.size(); i++)
        cnt += suf_sums.size() - h(x - pref_sums[i] + 1);

    return cnt;
}

int main()
{
    freopen("aliens.in","r",stdin);
    freopen("aliens.out","w",stdout);

    ios_base::sync_with_stdio(false);
    cin.tie(false);
    cout.tie(false);

    ll k;
    cin >> n >> m >> k;
    S = m - m / 2;

    p.resize(m);
    ll c;
    for(ll i = 0; i<m; i++)
        for(ll j = 0; j<n; j++)
        {
            cin >> c;
            p[i].pb(c);
        }

    generatePref(0, 0);
    sort(pref_sums.begin(),pref_sums.end());

    generateSuf(S, 0);
    sort(suf_sums.begin(), suf_sums.end());

    ll A = pref_sums[0] + suf_sums[0] - 1,
       B = pref_sums.back() + suf_sums.back();
    while(B-A > 1)
    {
        ll C = (B+A)/2;

        if(f(C) < k) B = C;
        else A = C;
    }

    ll L = k - f(B);
    ll len = 0, sum = 0, ans = 0, L1 = 0;
    while(len < m)
    {
        ans *= n; ans--;

        for(ll i = 0; i<n; i++)
        {
            ans++;

            ll cur = 0;
            if(len<S) g1(len+1, sum+p[len][i], B, cur);
            else g2(len+1, sum+p[len][i], B, cur);

            if(L1 + cur < L) L1 += cur;
            else
            {
                sum += p[len][i];
                break;
            }
        }

        len ++;
    }

    string ss = "";
    while(ss.size() < m)
    {
        ss = ss + char(ans%n + ll('a'));
        ans /= n;
    }

    for(ll i = m-1; i>=0; i--) cout << ss[i];
    cout << '\n';
}
