#include<bits/stdc++.h>

using namespace std;

const int Nmax = 1e5 + 100;
unsigned n, p = 41;
unsigned fd_hesh[Nmax], bd_hesh[Nmax], ppow[Nmax],
    arr[Nmax];

inline bool sym(int a, int b) {
    return (fd_hesh[b] - fd_hesh[a-1]) * ppow[n-b] == (bd_hesh[a-1] - bd_hesh[b]) * ppow[a-1];
}

int main() {
    freopen("symmetry.in", "r", stdin);
    freopen("symmetry.out", "w", stdout);

    int test;
    scanf("%d", &test);
    ppow[0] = 1;
    for(int i = 1;i < Nmax;++i)
        ppow[i] = ppow[i-1] * p;

    bool correct;
    while(test--) {
        cin >> n;
        for(int i = 0;i < n;++i) {
                scanf("%u", &arr[i]);
            if(i)
                arr[i-1] = arr[i] - arr[i-1];
        }
        n--;
        fd_hesh[0] = 0;
        bd_hesh[n] = 0;
        for(int i = 1;i <= n;++i) {
            fd_hesh[i] = fd_hesh[i-1] + arr[i-1] * ppow[i-1];
            bd_hesh[n-i] = bd_hesh[n-i+1] + arr[n-i] * ppow[i-1];
        }
        for(int i = 0; i < n;++i) {
            if(sym(1, i) && sym(i+2, n)) {
                correct = true;
                for(int j = 0;j < i;++j) {
                    if(arr[j] != arr[i-j-1]) {
                        correct = false;
                        break;
                    }
                }
                for(int j = i+1;j < n;++j) {
                    if(arr[j] != arr[n - j + i]) {
                        correct = false;
                        break;
                    }
                }
                if(correct) {
                    printf("%d\n", i+1);
                    break;
                }
            }
            if(i == n-1)
                printf("0\n");
        }
    }
    return 0;
}
