/*GCC*/
#include <bits/stdc++.h>

using namespace std;

int n,m;
long long k;
vector<vector<int> >p,s,in;

inline void init(){
    p.resize(m/2);
    s.resize(m-m/2);
    in.assign(m,vector<int>(n));
}

long long f(int a){
    if(m == 1)
        return s[0].end() - upper_bound(s[0].begin(),s[0].end(),a);
    long long res = 0;
    int upp = 0,sz = s.back().size();
    for(int i = p.back().size() - 1;i >= 0;i--){
        while(upp < sz && s.back()[upp] <= a - p.back()[i])
            upp++;
        if(upp == sz)
            break;
        res += sz - upp;
    }
    return res;
}

long long g(int from,int sum){
    if(from >= m && !sum)
        return 1;
    if(from >= m)
        return 0;
    if(from < m/2){
        int upp = s.back().size(),
            low = s.back().size(),
            ind = m/2 - 1 - from;
        long long res = 0;
        for(int i = 0;i < p[ind].size();i++){
            while(upp && s.back()[upp-1] > sum - p[ind][i])
                upp--;
            while(low && s.back()[low-1] >= sum - p[ind][i])
                low--;
            res += upp - low;
        }
        return res;
    }else{
        int ind = m - 1 - from;
        return upper_bound(s[ind].begin(),s[ind].end(),sum) -
                lower_bound(s[ind].begin(),s[ind].end(),sum);
    }
}

int get(string _s){
    int res = 0;
    for(int i = 0;i < _s.size();i++)
        res += in[i][_s[i] - 'a'];
    return res;
}

int main()
{
    freopen("aliens.in","r",stdin);
    freopen("aliens.out","w",stdout);
    cin >> n >> m >> k;
    init();
    for(int i = 0;i < m;i++)
        for(int j = 0;j < n;j++)
            cin >> in[i][j];
    if(m > 1)p[0] = in[m/2-1];
    s[0] = in[m-1];
    for(int i = m/2 - 2;i >= 0;i--){
        int cur = m / 2 - 1 - i;
        p[cur].clear();
        for(int j = 0;j < p[cur-1].size();j++)
            for(int t = 0;t < in[i].size();t++)
                p[cur].push_back(p[cur-1][j] + in[i][t]);
    }
    for(int i = m - 2;i >= m/2;i--){
        int cur = m - 1 - i;
        s[cur].clear();
        for(int j = 0;j < s[cur-1].size();j++)
            for(int t = 0;t < in[i].size();t++)
                s[cur].push_back(s[cur-1][j] + in[i][t]);
    }
    for(int i = 0;i < m/2;i++)
        sort(p[i].begin(),p[i].end());
    for(int i = 0;i < m - m/2;i++)
        sort(s[i].begin(),s[i].end());
    int l = -1,r = s.back().back() + 1;
    if(m > 1)
        r += p.back().back();
    while(r - l > 1){
        int m = (l + r) >> 1;
        if(f(m) < k)
            r = m;
        else
            l = m;
    }
    k -= f(r);
    string s = "";
    long long lss = 0;
    for(int i = 0;i < m;i++){
        for(char j = 'a';j < 'a' + n;j++){
            int sum = get(s + j);
            long long G = g(i + 1, r - sum);
            if(lss + G >= k){
                s += j;
                break;
            }else
                lss += G;
        }
    }
    cout << s << '\n';
    return 0;
}
