/*GCC*/
#include <bits/stdc++.h>

using namespace std;

const int nmax = 100002;
const unsigned int P = 29;

int n;

unsigned int d[nmax],h[nmax],bh[nmax],p[nmax];

unsigned int get(int l,int r){
    if(l < r){
        unsigned int temp = h[r];
        if(l)
            temp -= h[l-1];
        return temp * p[n-2-l];
    }else{
        unsigned int temp = bh[r];
        if(l < n-2)
            temp -= bh[l+1];
        return temp * p[l];
    }
}

inline bool pal(int l,int r){
    if(r <= l)
        return 1;
    unsigned int g1 = get(l,r),
                    g2 = get(r,l);
    return (g1 == g2);
}

bool check(int l,int r){
    if(r <= l)
        return 1;
    for(int i = 0;i < (r - l) / 2;i++){
        if(d[l + i] != d[r - i])
            return 0;
    }
    return 1;
}

int main()
{
    freopen("symmetry.in","r",stdin);
    freopen("symmetry.out","w",stdout);
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    int T;
    cin >> T;
    while(T--){
        unsigned int last,cur;
        cin >> n >> last;
        p[0] = 1;
        for(int i = 1;i <= n;i++)
            p[i] = p[i-1] * P;
        for(int i = 0;i < n-1;i++){
            cin >> cur;
            d[i] = cur - last;
            last = cur;
        }
        h[0] = d[0];
        bh[n-2] = d[n-2];;
        for(int i = 1;i < n-1;i++)
            h[i] = h[i-1] + p[i] * d[i];
        for(int i = n-3;i >= 0;i--){
            bh[i] = bh[i+1] + p[n - 2 - i] * d[i];
        }
        bool ready = 0;
        for(int i = 0;i < n-1 && !ready;i++){
            if(pal(0,i-1) && pal(i+1,n-2)){
                if(check(0,i-1) && check(i+1,n-2)){
                    ready = 1;
                    cout << i + 1 << '\n';
                }
            }
        }
        if(!ready)
            cout << 0 << '\n';
    }
    return 0;
}
